.586
.model flat, stdcall

include windows.inc
include kernel32.inc
include advapi32.inc
include user32.inc
include macros.def

includelib kernel32.lib
includelib advapi32.lib
includelib user32.lib


comment *

	Installs and starts MemPhys driver

	*
.data

	szBinaryName		db	"\MemPhys.sys",NULL

.data?

	szBinaryPathname	db	512	dup	(?)
	szErrorMsg		db	512	dup	(?)
.code


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	InstallDriver		proc
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	local	hSCM:	dword
	local	hService: 	dword

	;==== Get path for MemPhys.sys ====
	invoke GetCurrentDirectory, 1024, addr szBinaryPathname
	invoke lstrcat, addr szBinaryPathname, addr szBinaryName

	;==== Install Driver ====
	invoke OpenSCManager, NULL, NULL, SC_MANAGER_ALL_ACCESS	
	mov hSCM, eax

     invoke CreateService, hSCM, SADD ("MemPhys"), SADD ("Physical Memory Viewer"),\				
	SERVICE_START or SERVICE_STOP or DELETE, SERVICE_KERNEL_DRIVER, SERVICE_DEMAND_START,\		
	 SERVICE_ERROR_IGNORE, addr szBinaryPathname, NULL, NULL, NULL,\ 				
	 NULL, NULL				

	.if !eax		
		invoke GetLastError
		invoke FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, NULL, eax, \
		 NULL, addr szErrorMsg, 1024, NULL
		invoke MessageBox, NULL, addr szErrorMsg, SADD ("CreateService Failed"),\
			 MB_ICONSTOP 
		jmp Exit
	.endif
	
	mov hService, eax

	invoke StartService, hService, NULL, NULL

	.if eax

		invoke MessageBox, NULL, SADD("MemPhys Driver is Started"), \
			SADD ("Success"), MB_OK
	.else
		invoke GetLastError
		invoke FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, NULL, eax, \
		 NULL, addr szErrorMsg, 1024, NULL
		invoke MessageBox, NULL, addr szErrorMsg, SADD ("StartService Failed"),\
			 MB_ICONSTOP 
	.endif

	invoke CloseServiceHandle, hService
Exit:
	invoke CloseServiceHandle, hSCM
	invoke ExitProcess, NULL

InstallDriver endp

;~~~~~~~~~~~~~~~~~~
end InstallDriver
;~~~~~~~~~~~~~~~~~~
	
		






