.586
.model flat, stdcall

include windows.inc
include kernel32.inc
include advapi32.inc
include user32.inc
include macros.def

includelib kernel32.lib
includelib advapi32.lib
includelib user32.lib

comment *
	
	Stops and Deletes MemPhys Driver

	*




.code

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	RemoveDriver		proc
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	
	local	hSCM:		dword
	local 	hService: 	dword
	local 	ServiceStatus:	SERVICE_STATUS

	invoke OpenSCManager, NULL, NULL, SC_MANAGER_ALL_ACCESS
	mov hSCM, eax
	invoke OpenService, hSCM, SADD ("MemPhys"), SERVICE_ALL_ACCESS

	.if !eax
		invoke MessageBox, NULL, SADD ("MemPhys not installed"),\
		SADD ("Error"), MB_ICONSTOP
		jmp Exit
	.endif

	mov hService, eax
	
	;=== Service is installed ===
	invoke ControlService, hService, SERVICE_CONTROL_STOP, addr ServiceStatus
	invoke DeleteService, hService
	
	.if eax
		invoke MessageBox, NULL, SADD ("MemPhys removed from system"),\
		 SADD ("OK"), MB_OK
		
	.else
		invoke MessageBox, NULL, SADD ("DeleteService Failed"), \
		 SADD ("Error"), MB_ICONSTOP
	.endif

	invoke CloseServiceHandle, hService
Exit:
	invoke CloseServiceHandle, hSCM
	invoke ExitProcess, NULL

RemoveDriver endp

;~~~~~~~~~~~~~~~~~~
end RemoveDriver
;~~~~~~~~~~~~~~~~~~
	